#ifndef __GS_TYPE_H_
#define __GS_TYPE_H_

#define GS_STORAGE_EMMC	0x20170428
#define GS_STORAGE_FLASH	0x20170502

/*******************************************
------Hidden part map for wp800, in sector, emmc
--------------------------------------------
---NAME              START             END            SIZE
mmcblk0p3(android_factcfg):
--- Fact:            0x4400    ~    0x53FF          0x1000(2MB)
mmcblk0p4(android_other):
--- Reserve0:        0x5400    ~    0x63FF          0x1000(2MB)
--- Nvram:           0x6400    ~    0x73FF          0x1000(2MB)
--- ImgHdr:          0x7400    ~    0x77FF          0x400(512KB)
--- Updflag:         0x7800    ~    0x78FF          0x100(128KB)
--- BCB:             0x7900    ~    0x79FF          0x100(128KB)
--- OTP:             0x7A00    ~    0x7BFF          0x200(256KB)
--- VCOM:            0x7C00    ~    0x7CFF          0x100(128K)
--- Reserve1:        0x7D00    ~    0xA3FF          0x2A00(4.875MB)
********************************************/

#define FACTORY_SECTOR_OFFSET		0x4400
#define FACTORY_SECTOR_SIZE			0x1000

#define RESERVE0_SECTOR_OFFSET		0x5400
#define RESERVE0_SECTOR_SIZE		0x1000
#define NVRAM_SECTOR_OFFSET			((RESERVE0_SECTOR_OFFSET)+(RESERVE0_SECTOR_SIZE))
#define NVRAM_SECTOR_SIZE			0x1000
#define IMGHDR_SECTOR_OFFSET		((NVRAM_SECTOR_OFFSET)+(NVRAM_SECTOR_SIZE))
#define IMGHDR_SECTOR_SIZE			0X0400
#define UPDFLAG_SECTOR_OFFSET		((IMGHDR_SECTOR_OFFSET)+(IMGHDR_SECTOR_SIZE))
#define UPDFLAG_SECTOR_SIZE			0X0100
#define BCB_SECTOR_OFFSET			((UPDFLAG_SECTOR_OFFSET)+(UPDFLAG_SECTOR_SIZE))
#define BCB_SECTOR_SIZE				0X0100
#define OTP_SECTOR_OFFSET			((BCB_SECTOR_OFFSET)+(BCB_SECTOR_SIZE))
#define OTP_SECTOR_SIZE				0X0200
#define VCOM_SECTOR_OFFSET			((OTP_SECTOR_OFFSET)+(OTP_SECTOR_SIZE))
#define VCOM_SECTOR_SIZE			0X0100
#define RESERVE1_SECTOR_OFFSET		((VCOM_SECTOR_OFFSET) + (VCOM_SECTOR_SIZE))

struct gxp22xx_nand_pdata {
	struct mtd_partition *parts;
	int nr_parts;
};

#define GS_PROD_SIGNATURE       0x43a78f39

typedef struct seg_header {
	uint32_t size_used;
	uint32_t size;
	uint16_t checksum;
	uint16_t seg_mark;
	uint32_t idt_len;
	uint32_t signature;
	uint32_t version;
	uint32_t date;
	uint16_t id;
	uint16_t hw_id;
	uint8_t md5sum[16];
	uint8_t reserved[16];
} seg_header_t;

#define SEG_PRELOADER_STR       "preloader"
#define SEG_LK_STR              "lk"
#define SEG_KERNEL_A_STR	"boota"
#define SEG_SYSTEM_A_STR	"systema"
#define SEG_KERNEL_B_STR	"bootb"
#define SEG_SYSTEM_B_STR	"systemb"
#define SEG_RECOVERY_STR	"recovery"

#define MTD_SEGHDR_COUNT	7

typedef struct {
	const  char *name;
	unsigned long start;
} prov_t;


typedef enum {
	SYSTEM_UNKONWN = 0,
	SYSTEM_A = 100,
	SYSTEM_B = 101
} sys_location_t;

typedef struct upd_flag {
	uint32_t cur_running;
	uint32_t last_upgraded;
	uint32_t signature;
	uint32_t timestamp;
} upd_flag_t;

#endif
