#!/bin/bash
if [ -z "$ANDROID_BUILD_TOP" ]; then
    echo "Error env, please source build/envsetup.sh first"
    exit 1
fi

function printHelp() {
	echo "
$0  -c    -----   clean kernel
$0  -b    -----   make bootimage
$0  -k    -----   make kernel (kernel make to $ANDROID_BUILD_TOP/device/mediatek/common/kernel)
$0  -h    -----   print this message
	"
}

shopt -s expand_aliases

cd $ANDROID_BUILD_TOP
source build/envsetup.sh 1 > /dev/null

if [ $# -eq 0 ]; then
	echo -e "\033[31m need arguments! \033[0m"
	printHelp
	exit 1
fi

while getopts "cbkh" arg
do
    case $arg in
        c)
        mmm ../kernel-3.18:clean-kernel
        ;;

        b)
        mmm ../kernel-3.18:bootimage
        ;;

        k)
        mmm ../kernel-3.18:kernel
        ;;

        h)
        printHelp
        ;;

        ?)
        printHelp
        exit 1
        ;;
    esac
done

