/*
 * Copyright (C) 2015 MediaTek Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef _DISP_HELPER_H_
#define _DISP_HELPER_H_

typedef enum {
	DISP_OPT_USE_CMDQ = 0,
	DISP_OPT_USE_M4U,
	DISP_OPT_MIPITX_ON_CHIP,
	DISP_OPT_USE_DEVICE_TREE,
	DISP_OPT_FAKE_LCM_X,
	DISP_OPT_FAKE_LCM_Y,
	DISP_OPT_FAKE_LCM_WIDTH,
	DISP_OPT_FAKE_LCM_HEIGHT,
	DISP_OPT_OVL_WARM_RESET,
	DISP_OPT_DYNAMIC_SWITCH_UNDERFLOW_EN,
	/* Begin: lowpower option*/
	DISP_OPT_SODI_SUPPORT,
	DISP_OPT_IDLE_MGR,
	DISP_OPT_IDLEMGR_SWTCH_DECOUPLE,
	DISP_OPT_IDLEMGR_ENTER_ULPS,
	DISP_OPT_SHARE_SRAM,
	DISP_OPT_DYNAMIC_SWITCH_MMSYSCLK,
	DISP_OPT_DYNAMIC_RDMA_GOLDEN_SETTING,
	DISP_OPT_IDLEMGR_DISABLE_ROUTINE_IRQ,
	DISP_OPT_MET_LOG, /* for met */
	/* End: lowpower option */
	DISP_OPT_DECOUPLE_MODE_USE_RGB565,
	DISP_OPT_NO_LCM_FOR_LOW_POWER_MEASUREMENT,
	DISP_OPT_NO_LK,
	DISP_OPT_BYPASS_PQ,
	DISP_OPT_ESD_CHECK_RECOVERY,
	DISP_OPT_ESD_CHECK_SWITCH,
	DISP_OPT_PRESENT_FENCE,
	DISP_OPT_PERFORMANCE_DEBUG,
	DISP_OPT_SWITCH_DST_MODE,
	DISP_OPT_MUTEX_EOF_EN_FOR_CMD_MODE,
	DISP_OPT_SCREEN_CAP_FROM_DITHER,
	DISP_OPT_BYPASS_OVL,
	DISP_OPT_FPS_CALC_WND,
	DISP_OPT_SMART_OVL,
	DISP_OPT_DYNAMIC_DEBUG,
	DISP_OPT_SHOW_VISUAL_DEBUG_INFO,
	DISP_OPT_RDMA_UNDERFLOW_AEE,
	DISP_OPT_HRT,
	DISP_OPT_PARTIAL_UPDATE,
	DISP_OPT_GMO_OPTIMIZE,
	DISP_OPT_CV_BYSUSPEND,
	DISP_OPT_DETECT_RECOVERY,
	DISP_OPT_DELAYED_TRIGGER,
	DISP_OPT_MUTEX_SOF_RESERVED_FOR_CMD_MODE,
	DISP_OPT_SHADOW_FORCE_COMMIT,
	DISP_OPT_READ_SHADOW_REG,
	DISP_OPT_SHADOW_BYPASS,
	DISP_OPT_DCM_ENBLE,
	DISP_OPT_SHADOW_REGISTER,	/* is chip has shadow register? */
	DISP_OPT_SHADOW_MODE,		/* 0:full; 1:force_commit; 2:bypass shadow */
	DISP_OPT_OVL_EXT_LAYER,		/* is ovl has ext layer support? */
	DISP_OPT_REG_PARSER_RAW_DUMP,
	DISP_OPT_NUM
} DISP_HELPER_OPT;

typedef enum {
	DISP_HELPER_STAGE_EARLY_PORTING,
	DISP_HELPER_STAGE_BRING_UP,
	DISP_HELPER_STAGE_NORMAL
} DISP_HELPER_STAGE;

void disp_helper_option_init(void);
int disp_helper_get_option(DISP_HELPER_OPT option);
int disp_helper_set_option(DISP_HELPER_OPT option, int value);
int disp_helper_set_option_by_name(const char *name, int value);
int disp_helper_get_option_list(char *stringbuf, int buf_len);

DISP_HELPER_STAGE disp_helper_get_stage(void);
const char *disp_helper_stage_spy(void);

struct disp_help_info {
	DISP_HELPER_OPT opt_enum;
	int opt_value;
	unsigned char opt_string[64];
};

extern struct disp_help_info help_info[];
extern const int help_info_cnt;

#endif
