/*
 * drivers/staging/gs/provision.c
 *
 * Driver for the provison.
 *
 * Copyright (C) 2012, 2013 GrandStream Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */

#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <linux/rslib.h>
#include <linux/moduleparam.h>
#include <linux/platform_device.h>
#include <linux/dma-mapping.h>
#include <linux/types.h>
#include <linux/clk.h>
#include <linux/interrupt.h>
#include <linux/semaphore.h>
#include <linux/io.h>
#include <linux/slab.h>
#include <linux/completion.h>
#include <linux/uaccess.h>
#include <linux/proc_fs.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#include <../fs/proc/internal.h>

#include <mach/gs_type.h>

extern int provision_install_proc_entry_flash(void);
extern int provision_install_proc_entry_mmc(void);

static int provision_install_proc_entry(void)
{
	int rval = 0;
	int storage = GS_STORAGE_EMMC;

	switch (storage) {
	case GS_STORAGE_FLASH:
#ifdef CONFIG_GS_STORAGE_FLASH
		printk("provision flash storage\n");
		rval = provision_install_proc_entry_flash();
#endif
		break;
	case GS_STORAGE_EMMC:
#ifdef CONFIG_GS_STORAGE_EMMC
		printk("provision emmc storage\n");
		rval = provision_install_proc_entry_mmc();
#endif
		break;
	default:
		break;
	}
	return rval;
}

static int __init
provision_init(void)
{
	provision_install_proc_entry();
	return 0;
}

static void __exit
provision_cleanup(void)
{
	remove_proc_entry("provision", NULL);
	return;
}

module_init(provision_init);
module_exit(provision_cleanup);

MODULE_AUTHOR("ygzhang@grandstream.com");
MODULE_DESCRIPTION("GS provision driver");
MODULE_LICENSE("GPL");
